<?php 
/*
Template Name: Single Post
*/

get_header();

$airkit_main_classes 	= array('airkit_single-post airkit_single-main');
$airkit_main_classes[] 	= ( 'y' == airkit_single_option( 'sticky_sidebar' ) ) ? 'sticky-sidebars-enabled' : '';
$meta = get_post_meta( $post->ID, 'airkit_post_settings', true );

$single_post_layout 	= airkit_single_option( 'single_post_layout' );
$local_post_layout 		= isset( $meta['single_post_layout'] ) ? $meta['single_post_layout'] : '';
$single_layouts 		= array('single1', 'single2', 'single3', 'single4');

/*
 * Get single layout style
 */
if ( ! in_array( $single_post_layout, $single_layouts ) ) {
	$single_post_layout = 'single1';
}

if ( in_array( $local_post_layout, $single_layouts ) ) {
	$single_post_layout = $local_post_layout;
}

?>

<!-- Ad area 1 -->
<?php
	if( airkit_option_value('advertising','ad_area_1') != '' ) {
		echo '<div class="container text-center airkit_advertising-container">' . airkit_option_value('advertising','ad_area_1') . '</div>';
	}
?>

<div class="single-content <?php echo implode(' ', $airkit_main_classes); ?>">
	<?php
		if ( have_posts() ) {

			while ( have_posts() ):

				the_post();

				$post_type = get_post_type(get_the_ID());

				if ( 'post' === $post_type ) {
					$post_type = $single_post_layout;
				}

				get_template_part('templates/' . $post_type.'');

			endwhile;
		}
	?>
</div>


<?php
	get_footer(); 
?>
